- Main Page
- Classes
- Files
- Directories
- Related Pages

- Class List
- Class Hierarchy
- Class Members

# OGRFeature Class Reference

`#include <ogr_feature.h>`

List of all members.

## Public Member Functions
| OGRFeature (OGRFeatureDefn *)
OGRFeatureDefn * | GetDefnRef ()
OGRErr | SetGeometryDirectly (OGRGeometry *)
OGRErr | SetGeometry (OGRGeometry *)
OGRGeometry * | GetGeometryRef ()
OGRGeometry * | StealGeometry ()
OGRFeature * | Clone ()
virtual OGRBoolean | Equal (OGRFeature *poFeature)
int | GetFieldCount ()
OGRFieldDefn * | GetFieldDefnRef (int iField)
int | GetFieldIndex (const char *pszName)
int | IsFieldSet (int iField)
void | UnsetField (int iField)
OGRField * | GetRawFieldRef (int i)
int | GetFieldAsInteger (int i)
double | GetFieldAsDouble (int i)
const char * | GetFieldAsString (int i)
const int * | GetFieldAsIntegerList (int i, int *pnCount)
const double * | GetFieldAsDoubleList (int i, int *pnCount)
char ** | GetFieldAsStringList (int i)
GByte * | GetFieldAsBinary (int i, int *pnCount)
int | GetFieldAsDateTime (int i, int *pnYear, int *pnMonth, int *pnDay, int *pnHour, int *pnMinute, int *pnSecond, int *pnTZFlag)
void | SetField (int i, int nValue)
void | SetField (int i, double dfValue)
void | SetField (int i, const char *pszValue)
void | SetField (int i, int nCount, int *panValues)
void | SetField (int i, int nCount, double *padfValues)
void | SetField (int i, char **papszValues)
void | SetField (int i, OGRField *puValue)
void | SetField (int i, int nCount, GByte *pabyBinary)
void | SetField (int i, int nYear, int nMonth, int nDay, int nHour=0, int nMinute=0, int nSecond=0, int nTZFlag=0)
long | GetFID ()
virtual OGRErr | SetFID (long nFID)
void | DumpReadable (FILE *)
OGRErr | SetFrom (OGRFeature *, int=TRUE)
virtual const char * | GetStyleString ()
virtual void | SetStyleString (const char *)
## Static Public Member Functions
static OGRFeature * | CreateFeature (OGRFeatureDefn *)
static void | DestroyFeature (OGRFeature *)

## Detailed Description

A simple feature, including geometry and attributes.

## Constructor & Destructor Documentation

OGRFeature::OGRFeature | ( | OGRFeatureDefn * | poDefnIn | ) |

  | Constructor Note that the OGRFeature will increment the reference count of it's defining OGRFeatureDefn. Destruction of the OGRFeatureDefn before destruction of all OGRFeatures that depend on it is likely to result in a crash. This method is the same as the C function OGR_F_Create(). Parameters:
  | poDefnIn | feature class (layer) definition to which the feature will adhere.

## Member Function Documentation

OGRFeature * OGRFeature::Clone | ( |  | ) |

| Duplicate feature. The newly created feature is owned by the caller, and will have it's own reference to the OGRFeatureDefn. This method is the same as the C function OGR_F_Clone(). Returns: new feature, exactly matching this feature.

OGRFeature * OGRFeature::CreateFeature | ( | OGRFeatureDefn * | poDefn | ) | `[static]`

  | Feature factory. This is essentially a feature factory, useful for applications creating features but wanting to ensure they are created out of the OGR/GDAL heap. Parameters:
  | poDefn | Feature definition defining schema.
Returns: new feature object with null fields and no geometry. May be deleted with delete.

void OGRFeature::DestroyFeature | ( | OGRFeature * | poFeature | ) | `[static]`

  | Destroy feature The feature is deleted, but within the context of the GDAL/OGR heap. This is necessary when higher level applications use GDAL/OGR from a DLL and they want to delete a feature created within the DLL. If the delete is done in the calling application the memory will be freed onto the application heap which is inappropriate. This method is the same as the C function OGR_F_Destroy(). Parameters:
  | poFeature | the feature to delete.

void OGRFeature::DumpReadable | ( | FILE * | fpOut | ) |

  | Dump this feature in a human readable form. This dumps the attributes, and geometry; however, it doesn't definition information (other than field types and names), nor does it report the geometry spatial reference system. This method is the same as the C function OGR_F_DumpReadable(). Parameters:
  | fpOut | the stream to write to, such as stdout. If NULL stdout will be used.

OGRBoolean OGRFeature::Equal | ( | OGRFeature * | poFeature | ) | `[virtual]`

  | Test if two features are the same. Two features are considered equal if the share them (pointer equality) same OGRFeatureDefn, have the same field values, and the same geometry (as tested by OGRGeometry::Equal()) as well as the same feature id. This method is the same as the C function OGR_F_Equal(). Parameters:
  | poFeature | the other feature to test this one against.
Returns: TRUE if they are equal, otherwise FALSE.

OGRFeatureDefn * OGRFeature::GetDefnRef | ( |  | ) | `[inline]`

| Fetch feature definition. This method is the same as the C function OGR_F_GetDefnRef(). Returns: a reference to the feature definition object.

long OGRFeature::GetFID | ( |  | ) | `[inline]`

| Get feature identifier. This method is the same as the C function OGR_F_GetFID(). Returns: feature id or OGRNullFID if none has been assigned.

GByte * OGRFeature::GetFieldAsBinary | ( | int | iField,
|  | int * | pnBytes
| ) |

  | Fetch field value as binary data. Currently this method only works for OFTBinary fields. This method is the same as the C function OGR_F_GetFieldAsBinary(). Parameters:
  | iField | the field to fetch, from 0 to GetFieldCount()-1.
  | pnBytes | location to put the number of bytes returned.
Returns: the field value. This data is internal, and should not be modified, or freed. It's lifetime may be very brief.

int OGRFeature::GetFieldAsDateTime | ( | int | iField,
|  | int * | pnYear,
|  | int * | pnMonth,
|  | int * | pnDay,
|  | int * | pnHour,
|  | int * | pnMinute,
|  | int * | pnSecond,
|  | int * | pnTZFlag
| ) |

  | Fetch field value as date and time. Currently this method only works for OFTDate, OFTTime and OFTDateTime fields. This method is the same as the C function OGR_F_GetFieldAsDateTime(). Parameters:
  | iField | the field to fetch, from 0 to GetFieldCount()-1.
  | int | pnYear (including century)
  | int | pnMonth (1-12)
  | int | pnDay (1-31)
  | int | pnHour (0-23)
  | int | pnMinute (0-59)
  | int | pnSecond (0-59)
  | int | pnTZFlag (0=unknown, 1=localtime, 100=GMT, see data model for details)
Returns: TRUE on success or FALSE on failure.

double OGRFeature::GetFieldAsDouble | ( | int | iField | ) |

  | Fetch field value as a double. OFTString features will be translated using atof(). OFTInteger fields will be cast to double. Other field types, or errors will result in a return value of zero. This method is the same as the C function OGR_F_GetFieldAsDouble(). Parameters:
  | iField | the field to fetch, from 0 to GetFieldCount()-1.
Returns: the field value.

const double * OGRFeature::GetFieldAsDoubleList | ( | int | iField,
|  | int * | pnCount
| ) |

  | Fetch field value as a list of doubles. Currently this method only works for OFTRealList fields. This method is the same as the C function OGR_F_GetFieldAsDoubleList(). Parameters:
  | iField | the field to fetch, from 0 to GetFieldCount()-1.
  | pnCount | an integer to put the list count (number of doubles) into.
Returns: the field value. This list is internal, and should not be modified, or freed. It's lifetime may be very brief. If *pnCount is zero on return the returned pointer may be NULL or non-NULL.

int OGRFeature::GetFieldAsInteger | ( | int | iField | ) |

  | Fetch field value as integer. OFTString features will be translated using atoi(). OFTReal fields will be cast to integer. Other field types, or errors will result in a return value of zero. This method is the same as the C function OGR_F_GetFieldAsInteger(). Parameters:
  | iField | the field to fetch, from 0 to GetFieldCount()-1.
Returns: the field value.

const int * OGRFeature::GetFieldAsIntegerList | ( | int | iField,
|  | int * | pnCount
| ) |

  | Fetch field value as a list of integers. Currently this method only works for OFTIntegerList fields. This method is the same as the C function OGR_F_GetFieldAsIntegerList(). Parameters:
  | iField | the field to fetch, from 0 to GetFieldCount()-1.
  | pnCount | an integer to put the list count (number of integers) into.
Returns: the field value. This list is internal, and should not be modified, or freed. It's lifetime may be very brief. If *pnCount is zero on return the returned pointer may be NULL or non-NULL.

const char * OGRFeature::GetFieldAsString | ( | int | iField | ) |

  | Fetch field value as a string. OFTReal and OFTInteger fields will be translated to string using sprintf(), but not necessarily using the established formatting rules. Other field types, or errors will result in a return value of zero. This method is the same as the C function OGR_F_GetFieldAsString(). Parameters:
  | iField | the field to fetch, from 0 to GetFieldCount()-1.
Returns: the field value. This string is internal, and should not be modified, or freed. It's lifetime may be very brief.

char ** OGRFeature::GetFieldAsStringList | ( | int | iField | ) |

  | Fetch field value as a list of strings. Currently this method only works for OFTStringList fields. This method is the same as the C function OGR_F_GetFieldAsStringList(). Parameters:
  | iField | the field to fetch, from 0 to GetFieldCount()-1.
Returns: the field value. This list is internal, and should not be modified, or freed. It's lifetime may be very brief.

int OGRFeature::GetFieldCount | ( |  | ) | `[inline]`

| Fetch number of fields on this feature. This will always be the same as the field count for the OGRFeatureDefn. This method is the same as the C function OGR_F_GetFieldCount(). Returns: count of fields.

OGRFieldDefn * OGRFeature::GetFieldDefnRef | ( | int | iField | ) | `[inline]`

  | Fetch definition for this field. This method is the same as the C function OGR_F_GetFieldDefnRef(). Parameters:
  | iField | the field to fetch, from 0 to GetFieldCount()-1.
Returns: the field definition (from the OGRFeatureDefn). This is an internal reference, and should not be deleted or modified.

int OGRFeature::GetFieldIndex | ( | const char * | pszName | ) | `[inline]`

  | Fetch the field index given field name. This is a cover for the OGRFeatureDefn::GetFieldIndex() method. This method is the same as the C function OGR_F_GetFieldIndex(). Parameters:
  | pszName | the name of the field to search for.
Returns: the field index, or -1 if no matching field is found.

OGRGeometry * OGRFeature::GetGeometryRef | ( |  | ) | `[inline]`

| Fetch pointer to feature geometry. This method is the same as the C function OGR_F_GetGeometryRef(). Returns: pointer to internal feature geometry. This object should not be modified.

OGRField * OGRFeature::GetRawFieldRef | ( | int | iField | ) | `[inline]`

  | Fetch a pointer to the internal field value given the index. This method is the same as the C function OGR_F_GetRawFieldRef(). Parameters:
  | iField | the field to fetch, from 0 to GetFieldCount()-1.
Returns: the returned pointer is to an internal data structure, and should not be freed, or modified.

const char * OGRFeature::GetStyleString | ( |  | ) | `[virtual]`

| Fetch style string for this feature. Set the OGR Feature Style Specification for details on the format of this string, and ogr_featurestyle.h for services available to parse it. This method is the same as the C function OGR_F_GetStyleString(). Returns: a reference to a representation in string format, or NULL if there isn't one.

int OGRFeature::IsFieldSet | ( | int | iField | ) | `[inline]`

  | Test if a field has ever been assigned a value or not. This method is the same as the C function OGR_F_IsFieldSet(). Parameters:
  | iField | the field to test.
Returns: TRUE if the field has been set, otherwise false.

OGRErr OGRFeature::SetFID | ( | long | nFID | ) | `[virtual]`

  | Set the feature identifier. For specific types of features this operation may fail on illegal features ids. Generally it always succeeds. Feature ids should be greater than or equal to zero, with the exception of OGRNullFID (-1) indicating that the feature id is unknown. This method is the same as the C function OGR_F_SetFID(). Parameters:
  | nFID | the new feature identifier value to assign.
Returns: On success OGRERR_NONE, or on failure some other value.

void OGRFeature::SetField | ( | int | iField,
|  | int | nYear,
|  | int | nMonth,
|  | int | nDay,
|  | int | nHour = `0`,
|  | int | nMinute = `0`,
|  | int | nSecond = `0`,
|  | int | nTZFlag = `0`
| ) |

  | Set field to date. This method currently only has an effect for OFTDate, OFTTime and OFTDateTime fields. This method is the same as the C function OGR_F_SetFieldDateTime(). Parameters:
  | iField | the field to set, from 0 to GetFieldCount()-1.
  | nYear | (including century)
  | nMonth | (1-12)
  | nDay | (1-31)
  | nHour | (0-23)
  | nMinute | (0-59)
  | nSecond | (0-59)
  | nTZFlag | (0=unknown, 1=localtime, 100=GMT, see data model for details)

void OGRFeature::SetField | ( | int | iField,
|  | int | nBytes,
|  | GByte * | pabyData
| ) |

  | Set field to binary data. This method currently on has an effect of OFTBinary fields. This method is the same as the C function OGR_F_SetFieldBinary(). Parameters:
  | iField | the field to set, from 0 to GetFieldCount()-1.
  | nBytes | bytes of data being set.
  | pabyData | the raw data being applied.

void OGRFeature::SetField | ( | int | iField,
|  | OGRField * | puValue
| ) |

  | Set field. The passed value OGRField must be of exactly the same type as the target field, or an application crash may occur. The passed value is copied, and will not be affected. It remains the responsibility of the caller. This method is the same as the C function OGR_F_SetFieldRaw(). Parameters:
  | iField | the field to fetch, from 0 to GetFieldCount()-1.
  | puValue | the value to assign.

void OGRFeature::SetField | ( | int | iField,
|  | char ** | papszValues
| ) |

  | Set field to list of strings value. This method currently on has an effect of OFTStringList fields. This method is the same as the C function OGR_F_SetFieldStringList(). Parameters:
  | iField | the field to set, from 0 to GetFieldCount()-1.
  | papszValues | the values to assign.

void OGRFeature::SetField | ( | int | iField,
|  | int | nCount,
|  | double * | padfValues
| ) |

  | Set field to list of doubles value. This method currently on has an effect of OFTRealList fields. This method is the same as the C function OGR_F_SetFieldDoubleList(). Parameters:
  | iField | the field to set, from 0 to GetFieldCount()-1.
  | nCount | the number of values in the list being assigned.
  | padfValues | the values to assign.

void OGRFeature::SetField | ( | int | iField,
|  | int | nCount,
|  | int * | panValues
| ) |

  | Set field to list of integers value. This method currently on has an effect of OFTIntegerList fields. This method is the same as the C function OGR_F_SetFieldIntegerList(). Parameters:
  | iField | the field to set, from 0 to GetFieldCount()-1.
  | nCount | the number of values in the list being assigned.
  | panValues | the values to assign.

void OGRFeature::SetField | ( | int | iField,
|  | const char * | pszValue
| ) |

  | Set field to string value. OFTInteger fields will be set based on an atoi() conversion of the string. OFTReal fields will be set based on an atof() conversion of the string. Other field types may be unaffected. This method is the same as the C function OGR_F_SetFieldString(). Parameters:
  | iField | the field to fetch, from 0 to GetFieldCount()-1.
  | pszValue | the value to assign.

void OGRFeature::SetField | ( | int | iField,
|  | double | dfValue
| ) |

  | Set field to double value. OFTInteger and OFTReal fields will be set directly. OFTString fields will be assigned a string representation of the value, but not necessarily taking into account formatting constraints on this field. Other field types may be unaffected. This method is the same as the C function OGR_F_SetFieldDouble(). Parameters:
  | iField | the field to fetch, from 0 to GetFieldCount()-1.
  | dfValue | the value to assign.

void OGRFeature::SetField | ( | int | iField,
|  | int | nValue
| ) |

  | Set field to integer value. OFTInteger and OFTReal fields will be set directly. OFTString fields will be assigned a string representation of the value, but not necessarily taking into account formatting constraints on this field. Other field types may be unaffected. This method is the same as the C function OGR_F_SetFieldInteger(). Parameters:
  | iField | the field to fetch, from 0 to GetFieldCount()-1.
  | nValue | the value to assign.

OGRErr OGRFeature::SetFrom | ( | OGRFeature * | poSrcFeature,
|  | int | bForgiving = `TRUE`
| ) |

  | Set one feature from another. Overwrite the contents of this feature from the geometry and attributes of another. The poSrcFeature does not need to have the same OGRFeatureDefn. Field values are copied by corresponding field names. Field types do not have to exactly match. SetField() method conversion rules will be applied as needed. This method is the same as the C function OGR_F_SetFrom(). Parameters:
  | poSrcFeature | the feature from which geometry, and field values will be copied.
  | bForgiving | TRUE if the operation should continue despite lacking output fields matching some of the source fields.
Returns: OGRERR_NONE if the operation succeeds, even if some values are not transferred, otherwise an error code.

OGRErr OGRFeature::SetGeometry | ( | OGRGeometry * | poGeomIn | ) |

  | Set feature geometry. This method updates the features geometry, and operate exactly as SetGeometryDirectly(), except that this method does not assume ownership of the passed geometry, but instead makes a copy of it. This method is the same as the C function OGR_F_SetGeometry(). Parameters:
  | poGeomIn | new geometry to apply to feature.
Returns: OGRERR_NONE if successful, or OGR_UNSUPPORTED_GEOMETRY_TYPE if the geometry type is illegal for the OGRFeatureDefn (checking not yet implemented).

OGRErr OGRFeature::SetGeometryDirectly | ( | OGRGeometry * | poGeomIn | ) |

  | Set feature geometry. This method updates the features geometry, and operate exactly as SetGeometry(), except that this method assumes ownership of the passed geometry. This method is the same as the C function OGR_F_SetGeometryDirectly(). Parameters:
  | poGeomIn | new geometry to apply to feature.
Returns: OGRERR_NONE if successful, or OGR_UNSUPPORTED_GEOMETRY_TYPE if the geometry type is illegal for the OGRFeatureDefn (checking not yet implemented).

void OGRFeature::SetStyleString | ( | const char * | pszString | ) | `[virtual]`

  | Set feature style string. This method is the same as the C function OGR_F_SetStyleString(). Parameters:
  | pszString | the style string to apply to this feature, cannot be NULL.

OGRGeometry * OGRFeature::StealGeometry | ( |  | ) |

| Take away ownership of geometry. Fetch the geometry from this feature, and clear the reference to the geometry on the feature. This is a mechanism for the application to take over ownship of the geometry from the feature without copying. Sort of an inverse to SetGeometryDirectly(). After this call the OGRFeature will have a NULL geometry. Returns: the pointer to the geometry.

void OGRFeature::UnsetField | ( | int | iField | ) |

  | Clear a field, marking it as unset. This method is the same as the C function OGR_F_UnsetField(). Parameters:
  | iField | the field to unset.

The documentation for this class was generated from the following files:

- ogr_feature.h
- ogrfeature.cpp

Generated for GDAL by 1.4.5.